/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using OldMoatGames;using System;using OldMoatGames;using System.Linq;using Battlehub.RTCommon;namespace PluginIdea{    public class DynamicDecal : MVRScript, IGL    {        public struct BlendMode        {            public const int Zero = 0;            public const int One = 1;            public const int DstColor = 2;            public const int SrcColor = 3;            public const int OneMinusDstColor = 4;            public const int SrcAlpha = 5;            public const int OneMinusSrcColor = 6;            public const int DstAlpha = 7;            public const int OneMinusDstAlpha = 8;            public const int SrcAlphaSaturate = 9;            public const int OneMinusSrcAlpha = 10;        }        private List<string> blendModes = new List<string> { "NormalBlend", "Multiply", "DoubleMultiply", "SoftAdditive", "LinearDodge" };        private TextureSettings abedoTextureSetting = new TextureSettings() { compress = true, linearColor = false };        private TextureSettings maskTextureSetting = new TextureSettings() { compress = true, linearColor = false };        private TextureSettings emissionTextureSetting = new TextureSettings() { compress = true, linearColor = false };                private JSONStorableColor mainColor;        private JSONStorableFloat mainAlpha;        private JSONStorableFloat glossiness;        private JSONStorableUrl abedoTextureUrl;        private JSONStorableUrl maskTextureUrl;        private JSONStorableString test;        private JSONStorableUrl abedoGifTextureUrl;        private JSONStorableUrl normalTextureUrl;        private JSONStorableFloat metallic;        private JSONStorableUrl metallicMapUrl;        private JSONStorableColor emissionColor;        private JSONStorableFloat cutoutRadio;        private JSONStorableFloat occlusion;        private JSONStorableFloat scaleX;        private JSONStorableFloat fieldOfView;        private JSONStorableFloat farClipPlane;        private JSONStorableUrl metallicGlossMap;        private JSONStorableUrl emissionMapUrl;        private JSONStorableUrl occlusionMapUrl;        private JSONStorableStringChooser blendModeChooser;        private JSONStorableBool isOrthographic;        private JSONStorableStringChooser IgnoreLayers;        private TimerManager timerManager;        private bool isShowGizmos = true;        private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();        private List<Texture2D> decalTextures;        private Material defaultMat;        private float abdeoHWRaido = 1;        private bool isExternalResourcesLoaded;        private bool IsExternalResourcesLoaded        {            get { return this.isExternalResourcesLoaded; }        }        private Material Mat;        private Projector decalProjector;        private Projector DecalProjector        {            get {                if (decalProjector == null)                {                    CreateProjectorObject();                }                return decalProjector;            }        }        public override void Init()        {            base.Init();            if (containingAtom.type != "Empty")            {                SuperController.LogError(Location.GetStr(Location.NeedEmptyAtom));                return;            }            timerManager = new TimerManager();            SuperController.singleton.onSceneLoadedHandlers += HideAllPersonMesh;            SuperController.singleton.onAtomAddedHandlers += OnAtomAdded;            ResourceInit();            UIInit();        }        private void Start()        {            GLRenderer.Instance.Add(this);        }                private void UIInit()        {            Utils.OnInitUI(CreateUIElement);            Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfoDynamicDecal), 800, true);                                    Utils.SetupSpacer(this, 20, true);            mainColor = Utils.SetupColor(this, Location.GetStr(Location.MainColor), Color.white, true);            mainColor.setCallbackFunction = (h, s, v) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetColor("_Color", Color.HSVToRGB(h, s, v));            };            emissionColor = Utils.SetupColor(this, Location.GetStr(Location.EmissionColor), Color.black, true);            emissionColor.setCallbackFunction = (h, s, v) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetColor("_EmissionColor", Color.HSVToRGB(h, s, v));            };            isOrthographic = Utils.SetupToggle(this, Location.GetStr(Location.IsOrthographic), true, false);            isOrthographic.setCallbackFunction = (val) => {                if (!IsExternalResourcesLoaded) return;                DecalProjector.orthographic = val;            };                        Utils.SetupSpacer(this, 60, false);            scaleX = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.SizeX), 0.5f, 0.1f, 5f, false);            scaleX.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                DecalProjector.orthographicSize = val;            };            fieldOfView = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.FieldOfView), 30f, 0, 180, false);            fieldOfView.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                DecalProjector.fieldOfView = val;            };            farClipPlane = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.FarClipPlane), 1, 0.1f, 5, false);            farClipPlane.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                DecalProjector.farClipPlane = val;            };            blendModeChooser = Utils.SetupStringChooser(this, Location.GetStr(Location.BlendMode), blendModes, false);            blendModeChooser.setCallbackFunction = (val) => {                if (!IsExternalResourcesLoaded) return;                cutoutRadio.val = 0.5f;                switch (val)                {                    case "NormalBlend":                        Mat.SetInt("_SrcBlend", BlendMode.SrcAlpha);                        Mat.SetInt("_DstBlend", BlendMode.OneMinusSrcAlpha);                        cutoutRadio.val = 0;                        break;                    case "Multiply":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.Zero);                        break;                    case "DoubleMultiply":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.SrcColor);                        break;                    case "SoftAdditive":                        Mat.SetInt("_SrcBlend", BlendMode.DstColor);                        Mat.SetInt("_DstBlend", BlendMode.One);                        cutoutRadio.val = 0;                        break;                    case "LinearDodge":                        Mat.SetInt("_SrcBlend", BlendMode.One);                        Mat.SetInt("_DstBlend", BlendMode.One);                        break;                    default:                        break;                }            };            ParaMeterSet();        }        private void ResourceInit()        {            decalTextures = new List<Texture2D>() {                abedoTex, matallicTex, normalTex, occlusionTex, emssionTex            };            HideAllPersonMesh();            string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/dynamicdecal.assetbundle";            Request request = new Request { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        private void OnAssetBundleLoaded(Request request)        {            Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();            for (int i = 0; i < shaders.Length; i++)            {                                if (!dic_BundleShaders.ContainsKey(shaders[i].name))                {                    dic_BundleShaders.Add(shaders[i].name, shaders[i]);                }            }            CreateProjectorObject();        }                private Texture2D abedoTex, matallicTex, normalTex, occlusionTex, emssionTex, maskTex;        private void ParaMeterSet()        {                        Utils.SetupToggle(this, Location.GetStr(Location.ShowGizmos), true, false).setCallbackFunction = (val) =>            {                isShowGizmos = val;            };            Utils.SetupSpacer(this, 40, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.CommonParametersSubtitle), 45, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.AbedoSubtitle), 35, false);            abedoTextureUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainDecalTexure), $"Custom/Assets/MyAssets", false, abedoTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (abedoTex != null) Destroy(abedoTex);                abedoTex = tex;                Mat.SetTexture("_MainTex", abedoTex);                SyncDecalSize();            });            mainAlpha = Utils.SetupSliderFloatWithRange(this, Location.GetStr(Location.MainAlpha), 1, 0f, 1f, false);            mainAlpha.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Color color = Mat.GetColor("_Color");                color.a = val;                Mat.SetColor("_Color", color);            };            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_MainTex"));                abedoTextureUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_MainTex"));                Mat.SetTexture("_MainTex", defaultMat.GetTexture("_MainTex"));            }, false);                        Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.MaskSubtitle), 35, false);            maskTextureUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMaskTexure), $"Custom/Assets/MyAssets", false, maskTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (maskTex != null) Destroy(maskTex);                maskTex = tex;                Mat.SetTexture("_MaskTex", maskTex);            });            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_MaskTex"));                maskTextureUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_MaskTex"));                Mat.SetTexture("_MaskTex", defaultMat.GetTexture("_MaskTex"));            }, false);                        Utils.SetupSpacer(this, 20, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.EmissionSubtitle), 35, false);            emissionMapUrl = Utils.SetupTexture2DChooser(this, Location.GetStr(Location.SetMainEmissionTex), $"Custom/Assets/MyAssets", false, emissionTextureSetting, (tex) =>            {                if (!IsExternalResourcesLoaded) return;                if (emssionTex != null) Destroy(emssionTex);                emssionTex = tex;                Mat.SetTexture("_EmissionTex", emssionTex);            });            Utils.SetupTwinButton(this, Location.GetStr(Location.Reload), () => {                Destroy(Mat.GetTexture("_EmissionTex"));                emissionMapUrl.Reload();            }, Location.GetStr(Location.Remove), () => {                Destroy(Mat.GetTexture("_EmissionTex"));                Mat.SetTexture("_EmissionTex", defaultMat.GetTexture("_EmissionTex"));            }, false);                        cutoutRadio = Utils.SetupSliderFloat(this, Location.GetStr(Location.AlphaCutOff), 0.5f, 0f, 1f, false);            cutoutRadio.setCallbackFunction = (val) =>            {                if (!IsExternalResourcesLoaded) return;                Mat.SetFloat("_CutOff", val);            };        }        private void CreateProjectorObject()        {            GameObject decalObject = new GameObject("DecalObject");            decalObject.transform.SetParent(containingAtom.reParentObject.Find("object/rescaleObject"));            decalObject.transform.localPosition = Vector3.zero;            decalObject.transform.localRotation = Quaternion.identity;            decalObject.transform.localScale = Vector3.one;            decalProjector = decalObject.AddComponent<Projector>();            decalProjector.nearClipPlane = 0.1f;            decalProjector.farClipPlane = 1f;            decalProjector.fieldOfView = 30;            decalProjector.orthographic = true;            decalProjector.aspectRatio = abdeoHWRaido;            decalProjector.orthographicSize = 0.5f;            decalProjector.ignoreLayers = 1 << LayerMask.NameToLayer("Water");            Mat = new Material(dic_BundleShaders["PluginIdea/ProjectLight"]);            defaultMat = new Material(Mat);            decalProjector.material = this.Mat;        }        private void Update()        {            timerManager.Update();        }        private void SyncDecalSize()        {            if (abedoTex == null) return;            decalProjector.aspectRatio = abdeoHWRaido = (float)abedoTex.width / abedoTex.height;        }        private void HideAllPersonMesh()        {            timerManager.AddTimer(1.5f, () => {                                                isExternalResourcesLoaded = true;                abedoTextureUrl.Reload();                                                                emissionMapUrl.Reload();                maskTextureUrl.Reload();                                mainAlpha.setCallbackFunction(mainAlpha.val);                scaleX.setCallbackFunction(scaleX.val);                fieldOfView.setCallbackFunction(fieldOfView.val);                farClipPlane.setCallbackFunction(farClipPlane.val);                                                                cutoutRadio.setCallbackFunction(cutoutRadio.val);                mainColor.setCallbackFunction(mainColor.val.H, mainColor.val.S, mainColor.val.V);                emissionColor.setCallbackFunction(emissionColor.val.H, emissionColor.val.S, emissionColor.val.V);                blendModeChooser.setCallbackFunction(blendModeChooser.val);                SuperController.singleton.GetAtoms().Where(x => x.type == "Person").ToList().ForEach(ps =>                {                    HidePersonMesh(ps);                });            });        }        private void OnAtomAdded(Atom atom)        {            if (atom.type == "Person")            {                                timerManager.AddTimer(1f, () => {                    HidePersonMesh(atom);                });            }        }        private void HidePersonMesh(Atom person)        {            person.GetComponentsInChildren<Renderer>().ToList().ForEach(rd =>            {                Utils.SetLayer(rd.transform,LayerMask.NameToLayer("Water"));            });            var geo = person.transform.Find("rescale2/geometry");            Utils.SetLayer(geo, LayerMask.NameToLayer("Water"));        }        private void OnPostRender()        {            if (isShowGizmos && decalProjector != null)            {                GizmosHelper.DrawProjector(decalProjector);                GizmosHelper.DrawArrow3D(decalProjector.transform, decalProjector.farClipPlane * 0.6f, Color.green);            }        }        private void OnDestroy()        {            if (decalProjector != null)            {                Destroy(decalProjector.gameObject);            }            timerManager = null;            SuperController.singleton.onSceneLoadedHandlers -= HideAllPersonMesh;            SuperController.singleton.onAtomAddedHandlers -= OnAtomAdded;            GLRenderer.Instance.Remove(this);                        decalTextures.ForEach(tex => {                if (tex != null)                {                    Destroy(tex);                }            });            decalTextures.Clear();            Utils.OnDestroyUI();        }        public void Draw(int cullingMask)        {            OnPostRender();        }    }}